local chsound={}
chsound.event = {}
chsound.init = {}
chsound.active = gkini.ReadInt("ChSound", "active", 1)
chsound.channel = gkini.ReadInt("ChSound", "channel", 1)
chsound.volume = gkini.ReadString("ChSound", "volume", '0.35')
chsound.version = '1.0'

--## Choco ##--

local SOUND_NAME = 'user_sound'
local SOUND_PATH = "plugins/ChSound/SNDFILE.ogg" --change SNDFILE.ogg to your sound file

local sounds = {
	[SOUND_NAME] = gksound.GKLoadSound{soundname=SOUND_NAME,filename=SOUND_PATH},
}

function chsound.init:PLAYER_ENTERED_GAME(event, data)
	if chsound.active==1 then print('\127ffffffChSound On: monitoring '..chsound.channel..'\127o') end
end

function chsound.event:CHAT_MSG_CHANNEL(event, data)
	if chsound.active==1 and data.channelid == chsound.channel then
		gksound.GKPlaySound(SOUND_NAME, chsound.volume)
	end
end

function chsound:input(args)
	if args == nil then
		chsound.help()
	elseif args[1]:lower() == 'on' then
		chsound.active = 1
		print('ChSound On: monitoring '..chsound.channel)
		gkini.WriteInt("ChSound", "active", 1)
	elseif args[1]:lower() == 'off' then
		chsound.active = 0
		print('ChSound Off')
		gkini.WriteInt("ChSound", "active", 0)
	elseif args[1]:lower() == 'setch' then
		if args[2] == nil then
			print('You must specify a channel, currently monitoring '..chsound.channel)
		else
			chsound.channel = tonumber(args[2])
			print('ChSound monitoring channel '..chsound.channel)
			gkini.WriteInt("ChSound", "channel", chsound.channel)
		end
	elseif args[1]:lower() == 'setvol' then
		if args[2] == nil then
			print('You must specify percentage for the volume, either as a decimal or 2-100. Current volume: '..chsound.volume)
		else
			local vol = tonumber(args[2])
				if vol >=0 and vol <= 1 then
					--no conversion necessary
				elseif vol > 1 and vol <= 100 then
					vol = vol/100
				else vol = 1 end
								
			chsound.volume = vol
			print('ChSound volume set to '..chsound.volume)
			gkini.WriteString("ChSound", "volume", chsound.volume)
		end
	elseif args[1]:lower() == 'test' then
		chsound.test()
	else chsound.help() end
end

function chsound.test()
	gksound.GKPlaySound(SOUND_NAME, chsound.volume)
end

function chsound.help()
	print('\127ffffffChSound v'..chsound.version..' monitoring:'..chsound.channel..'  Available commands are:'..
	'\n\t/chsound on/off - turn plugin ON or OFF'..
	'\n\t/chsound setch \1270000ffNUMBER\127o - plays sound when activity on channel \1270000ffNUMBER\127o (only if not the active channel)'..
	'\n\t/chsound setvol \127ff77ffPERCENT\127o - sets volume: \127ff77ffPERCENT\127o can be a decimal or 2-100'..
	'\n\t/chsound test - sound test')
end

RegisterEvent(chsound.event, "CHAT_MSG_CHANNEL")
RegisterEvent(chsound.init, "PLAYER_ENTERED_GAME")
RegisterUserCommand("chsound", chsound.input)
